import { Connection } from "./Connection";
import { Driver } from "../driver/Driver";
import { ConnectionOptions } from "./ConnectionOptions";
/**
 * Array for the connections.
 */
export declare class ConnectionArray extends Array<Connection> {
    /**
     * Creates a new connection and pushes a connection to the array.
     */
    createAndPush(name: string, driver: Driver, options: ConnectionOptions): Connection;
    /**
     * Gets connection with a given name.
     */
    getWithName(name: string): Connection;
    /**
     * Checks if connection with a given name exist.
     */
    hasWithName(name: string): boolean;
    private removeByName(name);
}
