"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var Connection_1 = require("./Connection");
/**
 * Array for the connections.
 */
var ConnectionArray = (function (_super) {
    __extends(ConnectionArray, _super);
    function ConnectionArray() {
        _super.apply(this, arguments);
    }
    // -------------------------------------------------------------------------
    // Public Methods
    // -------------------------------------------------------------------------
    /**
     * Creates a new connection and pushes a connection to the array.
     */
    ConnectionArray.prototype.createAndPush = function (name, driver, options) {
        this.removeByName(name);
        var connection = new Connection_1.Connection(name, driver, options);
        this.push(connection);
        return connection;
    };
    /**
     * Gets connection with a given name.
     */
    ConnectionArray.prototype.getWithName = function (name) {
        return this.find(function (connection) { return connection.name === name; });
    };
    /**
     * Checks if connection with a given name exist.
     */
    ConnectionArray.prototype.hasWithName = function (name) {
        return !!this.getWithName(name);
    };
    // -------------------------------------------------------------------------
    // Private Methods
    // -------------------------------------------------------------------------
    ConnectionArray.prototype.removeByName = function (name) {
        var existConnection = this.find(function (connection) { return connection.name === name; });
        if (existConnection)
            this.splice(this.indexOf(existConnection), 1);
    };
    return ConnectionArray;
}(Array));
exports.ConnectionArray = ConnectionArray;
//# sourceMappingURL=ConnectionArray.js.map