"use strict";
var MetadataStorage_1 = require("../../metadata-builder/MetadataStorage");
var EventListenerTypes_1 = require("../../metadata-builder/types/EventListenerTypes");
var EntityListenerMetadata_1 = require("../../metadata-builder/metadata/EntityListenerMetadata");
/**
 * Calls a method on which this decorator is applied before this entity insertion.
 */
function BeforeInsert() {
    return function (object, propertyName) {
        MetadataStorage_1.defaultMetadataStorage.addEntityListenerMetadata(new EntityListenerMetadata_1.EntityListenerMetadata(object.constructor, propertyName, EventListenerTypes_1.EventListenerTypes.BEFORE_INSERT));
    };
}
exports.BeforeInsert = BeforeInsert;
//# sourceMappingURL=BeforeInsert.js.map