"use strict";
var MetadataStorage_1 = require("../../metadata-builder/MetadataStorage");
var EventListenerTypes_1 = require("../../metadata-builder/types/EventListenerTypes");
var EntityListenerMetadata_1 = require("../../metadata-builder/metadata/EntityListenerMetadata");
/**
 * Calls a method on which this decorator is applied before this entity removal.
 */
function BeforeRemove() {
    return function (object, propertyName) {
        MetadataStorage_1.defaultMetadataStorage.addEntityListenerMetadata(new EntityListenerMetadata_1.EntityListenerMetadata(object.constructor, propertyName, EventListenerTypes_1.EventListenerTypes.BEFORE_REMOVE));
    };
}
exports.BeforeRemove = BeforeRemove;
//# sourceMappingURL=BeforeRemove.js.map