"use strict";
var MetadataStorage_1 = require("../../metadata-builder/MetadataStorage");
var EventSubscriberMetadata_1 = require("../../metadata-builder/metadata/EventSubscriberMetadata");
/**
 * Classes decorated with this decorator will listen to ORM events and their methods will be triggered when event
 * occurs. Those classes must implement EventSubscriberInterface interface.
 */
function EventSubscriber() {
    return function (target) {
        MetadataStorage_1.defaultMetadataStorage.addEventSubscriberMetadata(new EventSubscriberMetadata_1.EventSubscriberMetadata(target));
    };
}
exports.EventSubscriber = EventSubscriber;
//# sourceMappingURL=EventSubscriber.js.map