import { RelationOptions } from "../../metadata-builder/options/RelationOptions";
import { ConstructorFunction } from "../../common/ConstructorFunction";
/**
 * Inverse side of the one-to-one relation. One-to-one relation allows to create direct relation between two entities.
 * Entity2 have only one Entity1. Entity2 is inverse side of the relation on Entity1. Does not storage id of the
 * Entity1. Entity1's id is storage on the one-to-one owner side.
 */
export declare function OneToOneInverse<T>(typeFunction: (type?: any) => ConstructorFunction<T>, options?: RelationOptions): Function;
/**
 * Inverse side of the one-to-one relation. One-to-one relation allows to create direct relation between two entities.
 * Entity2 have only one Entity1. Entity2 is inverse side of the relation on Entity1. Does not storage id of the
 * Entity1. Entity1's id is storage on the one-to-one owner side.
 */
export declare function OneToOneInverse<T>(typeFunction: (type?: any) => ConstructorFunction<T>, inverseSide?: string | ((object: T) => any), options?: RelationOptions): Function;
