import { Connection } from "../connection/Connection";
/**
 * Provides base functionality for all driver implementations.
 */
export declare abstract class BaseDriver {
    connection: Connection;
    protected logQuery(query: string): void;
    protected logQueryError(error: any): void;
    protected logFailedQuery(query: string): void;
    protected log(message: any, level: "log" | "debug" | "info" | "error"): void;
}
