import { MetadataStorage } from "./MetadataStorage";
import { EntityMetadata } from "./metadata/EntityMetadata";
import { NamingStrategy } from "../naming-strategy/NamingStrategy";
/**
 * Aggregates all metadata: table, column, relation into one collection grouped by tables for a given set of classes.
 */
export declare class EntityMetadataBuilder {
    private metadataStorage;
    private namingStrategy;
    constructor(metadataStorage: MetadataStorage, namingStrategy: NamingStrategy);
    /**
     * Builds a complete metadata aggregations for the given entity classes.
     */
    build(entityClasses: Function[]): EntityMetadata[];
    private isTableMetadataExtendsAbstractMetadata(tableMetadata, abstractMetadata);
    private filterObjectPropertyMetadatasIfNotExist<T>(newMetadatas, existsMetadatas);
}
