"use strict";
/**
 * This metadata interface contains all information about table's compound index.
 */
var CompoundIndexMetadata = (function () {
    // ---------------------------------------------------------------------
    // Constructor
    // ---------------------------------------------------------------------
    function CompoundIndexMetadata(target, fields) {
        this._target = target;
        this._fields = fields;
    }
    Object.defineProperty(CompoundIndexMetadata.prototype, "target", {
        // ---------------------------------------------------------------------
        // Getters
        // ---------------------------------------------------------------------
        /**
         * The object class to which this metadata is attached.
         */
        get: function () {
            return this._target;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CompoundIndexMetadata.prototype, "fields", {
        /**
         * Fields combination to be used as index.
         */
        get: function () {
            return this._fields;
        },
        enumerable: true,
        configurable: true
    });
    return CompoundIndexMetadata;
}());
exports.CompoundIndexMetadata = CompoundIndexMetadata;
//# sourceMappingURL=CompoundIndexMetadata.js.map