import { TableMetadata } from "../metadata/TableMetadata";
import { ColumnMetadata } from "../metadata/ColumnMetadata";
import { RelationMetadata } from "../metadata/RelationMetadata";
import { IndexMetadata } from "../metadata/IndexMetadata";
import { CompoundIndexMetadata } from "../metadata/CompoundIndexMetadata";
import { ForeignKeyMetadata } from "./ForeignKeyMetadata";
/**
 * Contains all entity metadata.
 */
export declare class EntityMetadata {
    private _table;
    private _columns;
    private _relations;
    private _indices;
    private _compoundIndices;
    private _foreignKeys;
    constructor(table: TableMetadata, columns: ColumnMetadata[], relations: RelationMetadata[], indices: IndexMetadata[], compoundIndices: CompoundIndexMetadata[], foreignKeys: ForeignKeyMetadata[]);
    name: string;
    target: Function;
    table: TableMetadata;
    columns: ColumnMetadata[];
    relations: RelationMetadata[];
    foreignKeys: ForeignKeyMetadata[];
    oneToOneRelations: RelationMetadata[];
    ownerOneToOneRelations: RelationMetadata[];
    oneToManyRelations: RelationMetadata[];
    manyToOneRelations: RelationMetadata[];
    manyToManyRelations: RelationMetadata[];
    ownerManyToManyRelations: RelationMetadata[];
    indices: IndexMetadata[];
    compoundIndices: CompoundIndexMetadata[];
    primaryColumn: ColumnMetadata;
    createDateColumn: ColumnMetadata;
    updateDateColumn: ColumnMetadata;
    hasPrimaryKey: boolean;
    /**
     * Creates a new entity.
     */
    create(): any;
    createPropertiesMap(): any;
    getEntityId(entity: any): any;
    hasColumnWithPropertyName(propertyName: string): boolean;
    hasColumnWithDbName(name: string): boolean;
    findColumnWithPropertyName(propertyName: string): ColumnMetadata;
    findColumnWithDbName(name: string): ColumnMetadata;
    hasRelationWithPropertyName(propertyName: string): boolean;
    hasRelationWithDbName(dbName: string): boolean;
    findRelationWithPropertyName(propertyName: string): RelationMetadata;
    findRelationWithDbName(propertyName: string): RelationMetadata;
    findRelationWithOneWithPropertyName(propertyName: string): RelationMetadata;
    findRelationWithOneWithDbName(name: string): RelationMetadata;
    findRelationWithManyWithPropertyName(propertyName: string): RelationMetadata;
    findRelationWithManyWithDbName(name: string): RelationMetadata;
    hasRelationWithOneWithPropertyName(propertyName: string): boolean;
    hasRelationWithManyWithPropertyName(propertyName: string): boolean;
    hasRelationWithOneWithName(name: string): boolean;
    hasRelationWithManyWithName(name: string): boolean;
}
