/**
 * This represents metadata of some object's property.
 */
export declare abstract class PropertyMetadata {
    /**
     * Class to which this decorator is applied.
     */
    private _target;
    /**
     * Class's property name to which this decorator is applied.
     */
    private _propertyName;
    constructor(target: Function, propertyName: string);
    /**
     * The object class to which this metadata is attached.
     */
    target: Function;
    /**
     * The name of the property of the object to which this metadata is attached.
     */
    propertyName: string;
}
