"use strict";
/**
 * This represents metadata of some object's property.
 */
var PropertyMetadata = (function () {
    // ---------------------------------------------------------------------
    // Constructor
    // ---------------------------------------------------------------------
    function PropertyMetadata(target, propertyName) {
        this._target = target;
        this._propertyName = propertyName;
    }
    Object.defineProperty(PropertyMetadata.prototype, "target", {
        // ---------------------------------------------------------------------
        // Accessors
        // ---------------------------------------------------------------------
        /**
         * The object class to which this metadata is attached.
         */
        get: function () {
            return this._target;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PropertyMetadata.prototype, "propertyName", {
        /**
         * The name of the property of the object to which this metadata is attached.
         */
        get: function () {
            return this._propertyName;
        },
        enumerable: true,
        configurable: true
    });
    return PropertyMetadata;
}());
exports.PropertyMetadata = PropertyMetadata;
//# sourceMappingURL=PropertyMetadata.js.map