import { NamingStrategy } from "../../naming-strategy/NamingStrategy";
/**
 * This metadata interface contains all information about specific table.
 */
export declare class TableMetadata {
    /**
     * Naming strategy used to generate and normalize table name.
     */
    namingStrategy: NamingStrategy;
    /**
     * Class to which this column is applied.
     */
    private _target;
    /**
     * Table name in the database.
     */
    private _name;
    /**
     * Indicates if this table is abstract or not. Regular tables can inherit columns from abstract tables.
     */
    private _isAbstract;
    constructor(target: Function, name: string, isAbstract: boolean);
    /**
     * Target entity of this table.
     * Target can be empty only for junction tables.
     */
    target: Function;
    /**
     * Table name in the database.
     */
    name: any;
    /**
     * Indicates if this table is abstract or not. Regular tables can inherit columns from abstract tables.
     */
    isAbstract: boolean;
}
