"use strict";
/**
 * This metadata interface contains all information about specific table.
 */
var TableMetadata = (function () {
    // ---------------------------------------------------------------------
    // Constructor
    // ---------------------------------------------------------------------
    function TableMetadata(target, name, isAbstract) {
        this._target = target;
        this._name = name;
        this._isAbstract = isAbstract;
    }
    Object.defineProperty(TableMetadata.prototype, "target", {
        // ---------------------------------------------------------------------
        // Getters
        // ---------------------------------------------------------------------
        /**
         * Target entity of this table.
         * Target can be empty only for junction tables.
         */
        get: function () {
            return this._target;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableMetadata.prototype, "name", {
        /**
         * Table name in the database.
         */
        get: function () {
            if (this._name)
                return this._name;
            return this.namingStrategy ? this.namingStrategy.tableName(this._target.name) : this._target.name;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableMetadata.prototype, "isAbstract", {
        /**
         * Indicates if this table is abstract or not. Regular tables can inherit columns from abstract tables.
         */
        get: function () {
            return this._isAbstract;
        },
        enumerable: true,
        configurable: true
    });
    return TableMetadata;
}());
exports.TableMetadata = TableMetadata;
//# sourceMappingURL=TableMetadata.js.map