import { AliasMap } from "../alias/AliasMap";
import { Connection } from "../../connection/Connection";
/**
 * Transforms raw sql results returned from the database into entity object.
 * Entity is constructed based on its entity metadata.
 */
export declare class RawSqlResultsToEntityTransformer {
    private connection;
    private aliasMap;
    constructor(connection: Connection, aliasMap: AliasMap);
    transform(rawSqlResults: any[]): any[];
    /**
     * Since db returns a duplicated rows of the data where accuracies of the same object can be duplicated
     * we need to group our result and we must have some unique id (primary key in our case)
     */
    private groupAndTransform(rawSqlResults, alias);
    /**
     * Transforms set of data results into single entity.
     */
    private transformIntoSingleResult(rawSqlResults, alias, metadata);
}
