import { SchemaBuilder } from "./SchemaBuilder";
import { MysqlDriver } from "../driver/MysqlDriver";
import { ColumnMetadata } from "../metadata-builder/metadata/ColumnMetadata";
import { ForeignKeyMetadata } from "../metadata-builder/metadata/ForeignKeyMetadata";
import { TableMetadata } from "../metadata-builder/metadata/TableMetadata";
export declare class MysqlSchemaBuilder extends SchemaBuilder {
    private driver;
    constructor(driver: MysqlDriver);
    getChangedColumns(tableName: string, columns: ColumnMetadata[]): Promise<{
        columnName: string;
        hasPrimaryKey: boolean;
    }[]>;
    checkIfTableExist(tableName: string): Promise<boolean>;
    addColumnQuery(tableName: string, column: ColumnMetadata): Promise<void>;
    dropColumnQuery(tableName: string, columnName: string): Promise<void>;
    addForeignKeyQuery(foreignKey: ForeignKeyMetadata): Promise<void>;
    dropForeignKeyQuery(foreignKey: ForeignKeyMetadata): Promise<void>;
    dropForeignKeyQuery(tableName: string, foreignKeyName: string): Promise<void>;
    getTableForeignQuery(table: TableMetadata): Promise<string[]>;
    getTableUniqueKeysQuery(tableName: string): Promise<string[]>;
    getPrimaryConstraintName(tableName: string): Promise<string>;
    dropIndex(tableName: string, indexName: string): Promise<void>;
    addUniqueKey(tableName: string, columnName: string, keyName: string): Promise<void>;
    getTableColumns(tableName: string): Promise<string[]>;
    changeColumnQuery(tableName: string, columnName: string, newColumn: ColumnMetadata, skipPrimary?: boolean): Promise<void>;
    createTableQuery(table: TableMetadata, columns: ColumnMetadata[]): Promise<void>;
    private query<T>(sql);
    private buildCreateColumnSql(column, skipPrimary);
    private normalizeType(column);
}
