import { Connection } from "../connection/Connection";
import { ColumnMetadata } from "../metadata-builder/metadata/ColumnMetadata";
/**
 * Broadcaster provides a helper methods to broadcast events to the subscribers.
 */
export declare class Broadcaster {
    private connection;
    constructor(connection: Connection);
    broadcastBeforeInsertEvent(entity: any): Promise<void>;
    broadcastBeforeUpdateEvent(entity: any, updatedColumns: ColumnMetadata[]): Promise<void>;
    broadcastBeforeRemoveEvent(entity: any, entityId: any): Promise<void>;
    broadcastAfterInsertEvent(entity: any): Promise<void>;
    broadcastAfterUpdateEvent(entity: any, updatedColumns: ColumnMetadata[]): Promise<void>;
    broadcastAfterRemoveEvent(entity: any, entityId: any): Promise<void>;
    broadcastLoadEvents(entity: any): Promise<void>;
    broadcastLoadEventsForAll(entities: any[]): Promise<void>;
    private isAllowedSubscribers(subscriber, cls);
}
